-- Player Trail script by Uaiek (U.S.G.N ID #41987)
-- Editing is fine, but do not forget to put my credits.

math.randomseed(os.time())
function array(s,v)
	local a = {}
	for i = 1,s do
		a[i] = v
	end
	return a
end

function array2D(s1,s2,v)
	local a = {}
	for i = 1,s1 do
		a[i] = {}
		for j = 1,s2 do
			a[i][j] = v
		end
	end
	return a
end

function removeimg(iid)
	local id = tonumber(iid)
	freeimage(id)
end

trail_alpha = 100 -- %
pl_count = array(32,0)
pl_img = array(32,0)
pl_toggle = array(32,false)
pl_clr = array2D(32,3,255)
pl_lastpos = array2D(32,2,0)
clr_select = array(32,4)
clr_count = array(10,0)

addhook("spawn","trail_fposset")
function trail_fposset(id)
	pl_lastpos[id][1], pl_lastpos[id][2] = player(id,"x"),player(id,"y")
end

addhook("join","trail_colorset")
function trail_colorset(id)
	pl_clr[id][1],pl_clr[id][2],pl_clr[id][3] = 255,255,255
	pl_toggle[id] = false
	clr_select[id] = 10
	msg2(id,'000255255This server is running "Player Trail" script by Uaiek.')
	msg2(id,'000200255Press F2 to enable the trail, Press F3 to change trail color')
	msg2(id,'000200255Press F4 to set back to the white trail.')
end

addhook("leave","trail_clrcount_remove")
function trail_clrcount_remove(id)
	if clr_count[clr_select[id]] > 0 then
		clr_count[clr_select[id]] = clr_count[clr_select[id]] - 1
	end
end

addhook("move","trail_move")
function trail_move(id,newx,newy)
	local kind = "trail"
	if player(id,"weapontype") == 78 then kind = "trail 2" end
	if pl_toggle[id] then
		if pl_count[id] % 6 == 0 then
			pl_img[id] = image("gfx/player/"..kind..".bmp",pl_lastpos[id][1],pl_lastpos[id][2],0)
			if clr_select[id] == 9 then
				imageblend(pl_img[id],1)
				imagecolor(pl_img[id],math.random(0,255),math.random(0,255),math.random(0,255))
			elseif clr_select[id] ~= 4 then
				imageblend(pl_img[id],1)
				imagecolor(pl_img[id],pl_clr[id][1],pl_clr[id][2],pl_clr[id][3])
			else
				imagecolor(pl_img[id],pl_clr[id][1],pl_clr[id][2],pl_clr[id][3])
			end
			imagealpha(pl_img[id],trail_alpha/100)
			imagepos(pl_img[id],pl_lastpos[id][1],pl_lastpos[id][2],player(id,"rot"))
			tween_alpha(pl_img[id],500,0)
			timer(500,"removeimg",pl_img[id])
		end
	end
	pl_lastpos[id][1],pl_lastpos[id][2] = newx,newy
	pl_count[id] = pl_count[id] + 1
	if pl_count[id] == 100 then pl_count[id] = 0 end
end
	
addhook("serveraction","trail_changecolor")
function trail_changecolor(id,a)
	if a == 1 then
		if pl_toggle[id] then
			pl_toggle[id] = false
			msg2(id,"255000000Trail is toggled off. Press F2 again to enable it.")
		else
			pl_toggle[id] = true
			msg2(id,"000255000Trail is toggled on. Press F2 again to disable it.")
		end
	end			
	if a == 2 then
		menu(id,"Change trail color,Red|"..clr_count[1].." using,Green|"..clr_count[2].." using,Aero|"..clr_count[3].." using,Shadow|"..clr_count[4].." using,Purple|"..clr_count[5].." using,Pink|"..clr_count[6].." using,Orange|"..clr_count[7].." using,Tea|"..clr_count[8].." using,Random Color|"..clr_count[9].." using")
	end
	if a == 3 then
		select(10,clr_select[id])
		clr_select[id] = 10
		pl_clr[id][1],pl_clr[id][2],pl_clr[id][3] = 255,255,255
	end
end

function select(s,d)
	clr_count[s] = clr_count[s] + 1
	if clr_count[d] > 0 then
		clr_count[d] = clr_count[d] - 1
	end
end

addhook("menu","trail_select")
function trail_select(id,t,s)
	if t == "Change trail color" then
		if s == 1 then
			pl_clr[id][1],pl_clr[id][2],pl_clr[id][3] = 255,0,0
		elseif s == 2 then
			pl_clr[id][1],pl_clr[id][2],pl_clr[id][3] = 0,255,0
		elseif s == 3 then
			pl_clr[id][1],pl_clr[id][2],pl_clr[id][3] = 0,255,255
		elseif s == 4 then
			pl_clr[id][1],pl_clr[id][2],pl_clr[id][3] = 0,0,0
		elseif s == 5 then
			pl_clr[id][1],pl_clr[id][2],pl_clr[id][3] = 255,0,255
		elseif s == 6 then
			pl_clr[id][1],pl_clr[id][2],pl_clr[id][3] = 255,150,255
		elseif s == 7 then
			pl_clr[id][1],pl_clr[id][2],pl_clr[id][3] = 255,150,0
		elseif s == 8 then
			pl_clr[id][1],pl_clr[id][2],pl_clr[id][3] = 150,200,60
		elseif s == 9 then
			pl_clr[id][1],pl_clr[id][2],pl_clr[id][3] = 999,999,999
		end
		select(s,clr_select[id])
		clr_select[id] = s
	end
end